////////////////////////////////////////////////////////////////////// 
// fugue/HaploSet.h 
// (c) 2000-2003 Goncalo Abecasis
// 
// This file is distributed as part of the FUGUE source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile FUGUE.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Tuesday July 06, 2004
// 
 
#ifndef __HAPLOSET_H__
#define __HAPLOSET_H__

#include "HaploGraph.h"

class HaplotypeSet : public MarkerInfo
   {
   public:
      String            setid;
      HaplotypeGraph ** graphs;
      int               graphCount;
      int               haploCount;
      double            weight;

      HaplotypeSet();
      ~HaplotypeSet();

      void LoadFromFile(FILE * input);

      void UpdateAlleleCounts();
      void StandardizeWeights();

      double Complexity();

      static int maxHaploCount;

   private:
      int  size;
      void Grow();
   };

class HaplotypeSets : public StringMap, MarkerInfo
   {
   public:
      HaplotypeSet * FindSet(const ::String & tag)
         {
         return (HaplotypeSet *) objects[Find(tag, create_set)];
         }

      void LoadFromFile(FILE * file);

      ~HaplotypeSets();

      void UpdateAlleleCounts();

      void Filter(int maxBits);
      void ShowCounts();

   private:
      static void * create_set();
   };

#endif
 
